//+------------------------------------------------------------------+
//|                                                    period=SD.mq4 |
//|                                                   Popovich Pasha |
//|                                                             doma |
//+------------------------------------------------------------------+
#property copyright "Popovich Pasha"
#property link      "doma"

#property indicator_chart_window
//---- indicator settings
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_width1 2
//---- input parameters
extern int       StdDev_period=100;
extern int       X_filter=10;
extern int       Y_filter=10;
extern int   count_bars=1000;

double StdDev[],MA[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);

   SetIndexBuffer(0,StdDev);
   SetIndexBuffer(1,MA);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"period_SD");   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit,i,bar=count_bars;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   int perMA;
   double x,y;
//********************************************************************************************
   for (i = limit; i >= 0; i--) 
      {
      StdDev[i]=iStdDev(NULL,0,StdDev_period,0,MODE_SMA,PRICE_MEDIAN,i);
      }
   for (i = limit; i >= 0; i--) 
      {
      x=X_filter;
      y=Y_filter;
      perMA=((StdDev[i] * 1000) * x) / y;
      }      
   for (i = limit; i >= 0; i--) 
      {
      MA[i]=iMA (NULL, 0, perMA, 0, MODE_SMA, PRICE_MEDIAN, i);
      }
//********************************************************************************************
   return(0);
  }

